<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex47.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex47.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex47.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex47.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 47: Automated Testing</h1>
                <p>Having to type commands into your game over and over to make sure it's working is annoying.  Wouldn't it be better to write little pieces of code that test your code?  Then when you make a change, or add a new thing to your program, you just &quot;run your tests&quot; and the tests make sure things are still working.  These automated tests won't catch all your bugs, but they will cut down on the time you spend repeatedly typing and running your code.</p>
<p>Every exercise after this one will not have a <em>What You Should See</em> section, but instead will have a <em>What You Should Test</em> section.  You will be writing automated tests for all of your code starting now, and this will hopefully make you an even better programmer.</p>
<p>I won't try to explain why you should write automated tests.  I will only say that you are trying to be a programmer, and programmers automate boring and tedious tasks.  Testing a piece of software is definitely boring and tedious, so you might as well write a little bit of code to do it for you.</p>
<p>That should be all the explanation you need because <em>your</em> reason for writing unit tests is to make your brain stronger.  You have gone through this book writing code to do things.  Now you are going to take the next leap and write code that knows about other code you have written.  This process of writing a test that runs some code you have written <em>forces</em> you to understand clearly what you have just written.  It solidifies in your brain exactly what it does and why it works and gives you a new level of attention to detail.</p>
<div class="section" id="writing-a-test-case">
<h1>Writing a Test Case</h1>
<p>We're going to take a very simple piece of code and write one simple test.  We're going to base this little test on a new project from your project skeleton.</p>
<p>First, make a <tt class="docutils literal">ex47</tt> project from your project skeleton.  Here are the steps you would take.  I'm going to give these instructions in English rather than show you how to type them so that <em>you</em> have to figure it out.</p>
<ol class="arabic simple">
<li>Copy <tt class="docutils literal">skeleton</tt> to <tt class="docutils literal">ex47</tt>.</li>
<li>Rename everything with <tt class="docutils literal">NAME</tt> to <tt class="docutils literal">ex47</tt>.</li>
<li>Change the word <tt class="docutils literal">NAME</tt> in all the files to <tt class="docutils literal">ex47</tt>.</li>
<li>Finally, remove all the <tt class="docutils literal">*.pyc</tt> files to make sure you're clean.</li>
</ol>
<p>Refer back to Exercise 46 if you get stuck, and if you can't do this easily then  maybe practice it a few times.</p>
<div class="note">
<p class="first admonition-title">Note</p>
<p class="last">Remember that you run the command <tt class="docutils literal">nosetests</tt> to run the tests.  You can run them with <tt class="docutils literal">python ex47_tests.py</tt> but it won't work as easily and you'll have to do it for each test file.</p>
</div>
<p>Next, create a simple file <tt class="docutils literal">ex47/game.py</tt> where you can put the code to test.  This will be a very silly little class that we want to test with this code in it:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex47--ex47--game.py-idio.html-1"></a><span class="k">class</span> <span class="nc">Room</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex47--ex47--game.py-idio.html-2"></a>
<a name="python--ex47--ex47--game.py-idio.html-3"></a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">description</span><span class="p">):</span>
<a name="python--ex47--ex47--game.py-idio.html-4"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span>
<a name="python--ex47--ex47--game.py-idio.html-5"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">description</span> <span class="o">=</span> <span class="n">description</span>
<a name="python--ex47--ex47--game.py-idio.html-6"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">paths</span> <span class="o">=</span> <span class="p">{}</span>
<a name="python--ex47--ex47--game.py-idio.html-7"></a>
<a name="python--ex47--ex47--game.py-idio.html-8"></a>    <span class="k">def</span> <span class="nf">go</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">direction</span><span class="p">):</span>
<a name="python--ex47--ex47--game.py-idio.html-9"></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">paths</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">direction</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
<a name="python--ex47--ex47--game.py-idio.html-10"></a>
<a name="python--ex47--ex47--game.py-idio.html-11"></a>    <span class="k">def</span> <span class="nf">add_paths</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">paths</span><span class="p">):</span>
<a name="python--ex47--ex47--game.py-idio.html-12"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">paths</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">paths</span><span class="p">)</span>
</pre></div>
</td></tr></table><p>Once you have that file, change the unit test skeleton to this:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex47--tests--ex47_tests.py-idio.html-1"></a><span class="kn">from</span> <span class="nn">nose.tools</span> <span class="kn">import</span> <span class="o">*</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-2"></a><span class="kn">from</span> <span class="nn">ex47.game</span> <span class="kn">import</span> <span class="n">Room</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-3"></a>
<a name="python--ex47--tests--ex47_tests.py-idio.html-4"></a>
<a name="python--ex47--tests--ex47_tests.py-idio.html-5"></a><span class="k">def</span> <span class="nf">test_room</span><span class="p">():</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-6"></a>    <span class="n">gold</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;GoldRoom&quot;</span><span class="p">,</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-7"></a>                <span class="sd">&quot;&quot;&quot;This room has gold in it you can grab. There&#39;s a</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-8"></a><span class="sd">                door to the north.&quot;&quot;&quot;</span><span class="p">)</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-9"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">gold</span><span class="o">.</span><span class="n">name</span><span class="p">,</span> <span class="s2">&quot;GoldRoom&quot;</span><span class="p">)</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-10"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">gold</span><span class="o">.</span><span class="n">paths</span><span class="p">,</span> <span class="p">{})</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-11"></a>
<a name="python--ex47--tests--ex47_tests.py-idio.html-12"></a><span class="k">def</span> <span class="nf">test_room_paths</span><span class="p">():</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-13"></a>    <span class="n">center</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;Center&quot;</span><span class="p">,</span> <span class="s2">&quot;Test room in the center.&quot;</span><span class="p">)</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-14"></a>    <span class="n">north</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;North&quot;</span><span class="p">,</span> <span class="s2">&quot;Test room in the north.&quot;</span><span class="p">)</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-15"></a>    <span class="n">south</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;South&quot;</span><span class="p">,</span> <span class="s2">&quot;Test room in the south.&quot;</span><span class="p">)</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-16"></a>
<a name="python--ex47--tests--ex47_tests.py-idio.html-17"></a>    <span class="n">center</span><span class="o">.</span><span class="n">add_paths</span><span class="p">({</span><span class="s1">&#39;north&#39;</span><span class="p">:</span> <span class="n">north</span><span class="p">,</span> <span class="s1">&#39;south&#39;</span><span class="p">:</span> <span class="n">south</span><span class="p">})</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-18"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">center</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;north&#39;</span><span class="p">),</span> <span class="n">north</span><span class="p">)</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-19"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">center</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;south&#39;</span><span class="p">),</span> <span class="n">south</span><span class="p">)</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-20"></a>
<a name="python--ex47--tests--ex47_tests.py-idio.html-21"></a><span class="k">def</span> <span class="nf">test_map</span><span class="p">():</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-22"></a>    <span class="n">start</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;Start&quot;</span><span class="p">,</span> <span class="s2">&quot;You can go west and down a hole.&quot;</span><span class="p">)</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-23"></a>    <span class="n">west</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;Trees&quot;</span><span class="p">,</span> <span class="s2">&quot;There are trees here, you can go east.&quot;</span><span class="p">)</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-24"></a>    <span class="n">down</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;Dungeon&quot;</span><span class="p">,</span> <span class="s2">&quot;It&#39;s dark down here, you can go up.&quot;</span><span class="p">)</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-25"></a>
<a name="python--ex47--tests--ex47_tests.py-idio.html-26"></a>    <span class="n">start</span><span class="o">.</span><span class="n">add_paths</span><span class="p">({</span><span class="s1">&#39;west&#39;</span><span class="p">:</span> <span class="n">west</span><span class="p">,</span> <span class="s1">&#39;down&#39;</span><span class="p">:</span> <span class="n">down</span><span class="p">})</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-27"></a>    <span class="n">west</span><span class="o">.</span><span class="n">add_paths</span><span class="p">({</span><span class="s1">&#39;east&#39;</span><span class="p">:</span> <span class="n">start</span><span class="p">})</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-28"></a>    <span class="n">down</span><span class="o">.</span><span class="n">add_paths</span><span class="p">({</span><span class="s1">&#39;up&#39;</span><span class="p">:</span> <span class="n">start</span><span class="p">})</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-29"></a>
<a name="python--ex47--tests--ex47_tests.py-idio.html-30"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">start</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;west&#39;</span><span class="p">),</span> <span class="n">west</span><span class="p">)</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-31"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">start</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;west&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;east&#39;</span><span class="p">),</span> <span class="n">start</span><span class="p">)</span>
<a name="python--ex47--tests--ex47_tests.py-idio.html-32"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">start</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;down&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;up&#39;</span><span class="p">),</span> <span class="n">start</span><span class="p">)</span>
</pre></div>
</td></tr></table><p>This file imports the <tt class="docutils literal">Room</tt> class you made in the <tt class="docutils literal">ex47.game</tt> module so that you can do tests on it.  There is then a set of tests that are functions starting with <tt class="docutils literal">test_</tt>.  Inside each test case there's a bit of code that makes a room or a set of rooms, and then makes sure the rooms work the way you expect them to work.  It tests out the basic room features, then the paths, then tries out a whole map.</p>
<p>The important functions here are <tt class="docutils literal">assert_equal</tt> which makes sure that variables you have set or paths you have built in a <tt class="docutils literal">Room</tt> are actually what you think they are.  If you get the wrong result, then <tt class="docutils literal">nosetests</tt> will print out an error message so you can go figure it out.</p>
</div>
<div class="section" id="testing-guidelines">
<h1>Testing Guidelines</h1>
<p>Follow this general loose set of guidelines when making your tests:</p>
<ol class="arabic simple">
<li>Test files go in <tt class="docutils literal">tests/</tt> and are named <tt class="docutils literal">BLAH_tests.py</tt> otherwise <tt class="docutils literal">nosetests</tt> won't run them.  This also keeps your tests from clashing with your other code.</li>
<li>Write one test file for each module you make.</li>
<li>Keep your test cases (functions) short, but do not worry if they are a bit messy.  Test cases are usually kind of messy.</li>
<li>Even though test cases are messy, try to keep them clean and remove any repetitive code you can.  Create helper functions that get rid of duplicate code.  You will thank me later when you make a change and then have to change your tests.  Duplicated code will make changing your tests more difficult.</li>
<li>Finally, do not get too attached to your tests.  Sometimes, the best way to redesign something is to just delete it and start over.</li>
</ol>
</div>
<div class="section" id="what-you-should-see">
<h1>What You Should See</h1>
<div class="highlight"><pre><span></span><a name="python--ex47.sh-session-pyg.html-1"></a><span class="gp">$</span> nosetests
<a name="python--ex47.sh-session-pyg.html-2"></a><span class="go">...</span>
<a name="python--ex47.sh-session-pyg.html-3"></a><span class="go">----------------------------------------------------------------------</span>
<a name="python--ex47.sh-session-pyg.html-4"></a><span class="go">Ran 3 tests in 0.008s</span>
<a name="python--ex47.sh-session-pyg.html-5"></a>
<a name="python--ex47.sh-session-pyg.html-6"></a><span class="go">OK</span>
</pre></div><p>That's what you should see if everything is working right.  Try causing an error to see what that looks like and then fix it.</p>
</div>
<div class="section" id="study-drills">
<h1>Study Drills</h1>
<ol class="arabic simple">
<li>Go read about nosetests more, and also read about alternatives.</li>
<li>Learn about Python's &quot;doc tests&quot; and see if you like them better.</li>
<li>Make your room more advanced, and then use it to rebuild your game yet again but this time, unit test as you go.</li>
</ol>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<dl class="docutils">
<dt>I get a syntax error when I run <tt class="docutils literal">nosetests</tt>.</dt>
<dd>If you get that then look at what the error says and fix that line of code or the ones above it.  Tools like <tt class="docutils literal">nosetests</tt> are running your code and the test code, so they will find syntax errors the same as running Python will.</dd>
<dt>I can't import <tt class="docutils literal">ex47.game</tt>?</dt>
<dd><p class="first">Make sure you create the <tt class="docutils literal">ex47/__init__.py</tt> file. Refer to Exercise 46 again to see how it's done.  If that's not the problem then do this on OSX/Linux:</p>
<pre class="literal-block">
export PYTHONPATH=.
</pre>
<p>And on Windows:</p>
<pre class="literal-block">
$env:PYTHONPATH = &quot;$env:PYTHONPATH;.&quot;
</pre>
<p class="last">Finally, make sure you're running ther tests with <tt class="docutils literal">nosetests</tt> not with just Python.</p>
</dd>
<dt>I get <tt class="docutils literal">UserWarning</tt> when I run <tt class="docutils literal">nosetests</tt>.</dt>
<dd>You probably have two versions of Python installed or you aren't using distribute.  Go back and install <tt class="docutils literal">distribute</tt> or <tt class="docutils literal">pip</tt> as I describe in Exercise 46.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex47.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex47.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
